﻿#include <queue>
#include <iostream>
#include <set>
#include <map>
#include <string>
#include <unordered_map>
#include <vector>
#include <numeric>
#include <cmath>
#include <iomanip>
#include <stack>
#include <unordered_set>

#define int long long
#define all(n) n.begin(), n.end()
#define rall(n) n.rbegin(), n.rend()
#define pb push_back
#define pf push_front
#define X first
#define Y second

using namespace std;


signed main() {
    int n, m, k;
    cin >> n >> m >> k;

    vector<vector<int>> v(n + 1);
    for (int i = 0; i < m; i++) {
        int x, y;
        cin >> x >> y;

        v[x].pb(y);
        v[y].pb(x);
    }

    set<int> st;

    for (int i = 0; i < k; i++) {
        int p, h;
        cin >> p >> h;

        queue<pair<int, int>> q;
        vector<bool> used(n + 1, 0);

        q.push({ p, h });
        used[p] = 1;

        while (!q.empty()) {
            pair<int, int> f = q.front();
            q.pop();
            int fr = f.X, sc = f.Y;

            st.insert(fr);

            if (sc > 0) {
                for (int A : v[fr]) {
                    if (!used[A]) {
                        used[A] = 1;
                        q.push({ A, sc - 1 });
                    }
                }
            }
        }
    }

    cout << st.size() << '\n';

    if (!st.empty()) {

        vector<int> sol(all(st));

        sort(all(sol));

        for (int A : sol) {
            cout << A << " ";
        }
    }
    else {
        cout << '\n';
    }

}