﻿#include <queue>
#include <iostream>
#include <set>
#include <map>
#include <string>
#include <unordered_map>
#include <vector>
#include <numeric>
#include <cmath>
#include <limits>
#include <iomanip>
#include <stack>
#include <unordered_set>

#define int long long
#define all(n) n.begin(), n.end()
#define rall(n) n.rbegin(), n.rend()
#define pb push_back
#define pf push_front
#define X first
#define Y second

using namespace std;

double sol(int x1, int y1, int x2, int y2) {
    return abs(x2 - x1) + abs(y2 - y1);
}

double pif(int x1, int y1, int x2, int y2) {
    return sqrt(pow((x2 - x1), 2) + pow((y2 - y1), 2));
}

bool dev(int x1, int y1, int x2, int y2, int x3, int y3, double& summ) {
    double a = pif(x1, y1, x2, y2);
    double b = pif(x2, y2, x3, y3);
    double c = pif(x1, y1, x3, y3);

    if (a * a + b * b == c * c) {
        summ = a + b;
        return 1;
    }
    else if (a * a + c * c == b * b) {
        summ = a + c; 
        return 1;
    }
    else if (b * b + c * c == a * a) {
        summ = b + c;
        return 1;
    }

    return 0; 
}

signed main() {
    double n;
    cin >> n;

    if (n == 2) {
        double x1, x2, y1, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        double f = sol(x1, y1, x2, y2);
        cout << f;
    }
    if (n == 3) {
        double x1, x2, y1, y2, x3, y3;
        cin >> x1 >> y1 >> x2 >> y2 >> x3 >> y3;
        double summ = 0.0;
        double d1 = sol(x1, y1, x2, y2) + sol(x2, y2, x3, y3);
        double d2 = sol(x1, y1, x3, y3) + sol(x3, y3, x2, y2);
        double d3 = sol(x2, y2, x1, y1) + sol(x1, y1, x3, y3);
        double d4 = sol(x2, y2, x3, y3) + sol(x3, y3, x1, y1);
        double d5 = sol(x3, y3, x1, y1) + sol(x1, y1, x2, y2);
        double d6 = sol(x3, y3, x2, y2) + sol(x2, y2, x1, y1);
        double f = min(d1, min(d2, min(d3, min(d4, min(d5, d6)))));

        cout << fixed << setprecision(20);

        if (dev(x1, y1, x2, y2, x3, y3, summ)) {
            cout << min(f, summ);
        }
        else {
            cout << f;
        }
        
    }
}