﻿#include <queue>
#include <iostream>
#include <set>
#include <map>
#include <string>
#include <unordered_map>
#include <vector>
#include <numeric>
#include <cmath>
#include <limits>
#include <iomanip>
#include <stack>
#include <unordered_set>

#define int long long
#define all(n) n.begin(), n.end()
#define rall(n) n.rbegin(), n.rend()
#define pb push_back
#define pf push_front
#define X first
#define Y second

using namespace std;


int MM = numeric_limits<int>::max();

void ffind(int x, vector<vector<pair<int, int>>>& v, vector<int>& used) {
    used[x] = 0;
    priority_queue<pair<int, int>, vector<pair<int, int>>, greater<>> q;
    q.push({ 0, x });

    while (!q.empty()) {
        pair<int, int> top = q.top();
        q.pop();

        int dis1 = top.X, dis2 = top.Y;


        for (auto A : v[dis2]) {
            int dis3 = A.X, mas = A.Y;

            int ndis = used[dis2] + mas;
            if (ndis < used[dis3]) {
                used[dis3] = ndis;
                q.push({ ndis, dis3 });
            }
        }
    }
}

signed main() {
    int n, m, k;
    cin >> n >> m >> k;

    vector<vector<pair<int, int>>> v(n + 1);

    for (int i = 0; i < m; i++) {
        int x, y;
        cin >> x >> y;
        v[x].emplace_back(y, 1);
        v[y].emplace_back(x, 1);
    }

    vector<pair<int, int>> z(k);
    for (int i = 0; i < k; i++) {
        int p, h;
        cin >> p >> h;
        z[i] = { p, h };
    }

    set<int> st;

    for (auto A : z) {
        int p = A.X;
        int h = A.Y;

        vector<int> used(n + 1, MM);

        ffind(p, v, used);

        for (int i = 1; i < n + 1; i++) {
            if (used[i] <= h) {
                st.insert(i);
            }
        }
    }
    
    cout << st.size() << '\n';
    for (int A : st) {
        cout << A << " ";
    }
}