﻿#include <queue>
#include <iostream>
#include <set>
#include <map>
#include <string>
#include <unordered_map>
#include <vector>
#include <numeric>
#include <cmath>
#include <limits>
#include <iomanip>
#include <stack>
#include <unordered_set>

#define int long long
#define all(n) n.begin(), n.end()
#define rall(n) n.rbegin(), n.rend()
#define pb push_back
#define pf push_front
#define X first
#define Y second

using namespace std;


double mahn(pair<int, int> a, pair<int, int> b) {
    return sqrt(pow(a.X - b.X, 2) + pow(a.Y - b.Y, 2));
}

signed main() {
    int n;
    cin >> n;

    vector<pair<int, int>> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i].X >> v[i].Y;
    }

    vector<int> p(n);
    for (int i = 0; i < n; i++) {
        p[i] = i;
    }

    double sol = 1e18;

    do {
        double curd = 0;
        for (int i = 1; i < n; i++) {
            curd += mahn(v[p[i - 1]], v[p[i]]);
        }
        sol = min(sol, curd);
    } 
    while (next_permutation(all(p)));

    cout << fixed << setprecision(20) << sol;

}